package com.inca.npbusi.saset.bms_sa_rec;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CDialog;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CHovBase;
import com.inca.np.gui.control.CNumberTextField;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.saset.bms_sa_rec.saset_tick.Bms_sa_set_tick_hov;
import com.inca.npbusi.saset.bms_sa_rec.saset_tick_mde.Bms_sa_rec_tick_mde_hov;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class Bms_sa_rec_mde extends CMdeModelAp {
   private String d = "";
   private String e = "";
   static String a;
   static String b;
   static CNumberTextField c;
   private CHovBase f = null;

   public String getEntryid() {
      return this.d;
   }

   public void setEntryid(String var1) {
      this.d = var1;
   }

   public String getEntryname() {
      return this.e;
   }

   public void setEntryname(String var1) {
      this.e = var1;
   }

   public Bms_sa_rec_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   protected CMasterModel createMastermodel() {
      return new Bms_sa_rec_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_sa_rec_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "sarecid";
   }

   public String getDetailRelatecolname() {
      return "sarecid";
   }

   public String getSaveCommandString() {
      return "Bms_sa_rec_mde.保存销售收款单";
   }

   protected boolean isAllownodetail() {
      return true;
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("禁止确定", ""));
      var1.add(new Apinfo("禁止回退确定", ""));
      var1.add(new Apinfo("禁止收款作废", ""));
      var1.add(new Apinfo("禁止预收款作废", ""));
      var1.add(new Apinfo("勾兑模式", ""));
      return var1;
   }

   protected int on_actionPerformed(String var1) {
      if (var1.equals("由结算单生成")) {
         this.genfromsaset();
         return 0;
      } else if (!var1.equals("自动生成")) {
         if (var1.equals("确定")) {
            var1 = this.getApvalue("禁止确定");
            if ("1".equals(var1)) {
               this.infoMessage("提示", "您没有执行该操作的权限！");
               return -1;
            } else {
               this.confirm();
               return 0;
            }
         } else if (var1.equals("回退确定")) {
            var1 = this.getApvalue("禁止回退确定");
            if ("1".equals(var1)) {
               this.infoMessage("提示", "您没有执行该操作的权限！");
               return -1;
            } else {
               this.unconfirm();
               return 0;
            }
         } else if (var1.equals("预收款作废")) {
            if ("1".equals(this.getApvalue("禁止预收款作废"))) {
               this.infoMessage("提示", "对不起，您没有权限执行该操作！");
               return -1;
            } else {
               this.prerecinvalid();
               return 0;
            }
         } else if (var1.equals("收款单作废")) {
            if ("1".equals(this.getApvalue("禁止收款作废"))) {
               this.infoMessage("提示", "对不起，您没有权限执行该操作！");
               return -1;
            } else {
               this.invalid();
               return 0;
            }
         } else if (var1.equals("切换独立单元")) {
            if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
               this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
               return -1;
            } else {
               if (Entrychose.setUserEntryInfo(this.frame)) {
                  this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                  this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                  this.getMasterModel().doRetrieve("1=2");
               }

               return 0;
            }
         } else {
            return super.on_actionPerformed(var1);
         }
      } else {
         int var2;
         if ((var2 = this.getMasterModel().getRow()) < 0) {
            this.errorMessage("错误", "请新增总单或选择一条预收款再由结算单生成！");
         } else {
            String var3 = this.getMasterModel().getItemValue(var2, "recmethod");
            String var4 = this.getMasterModel().getItemValue(var2, "customid");
            if (var3 != null && !var3.equals("")) {
               String var5;
               if ("1".equals(var3)) {
                  var3 = this.getMasterModel().getItemValue(var2, "usestatus");
                  if (!"1".equals(var3)) {
                     this.errorMessage("错误", "预收款必须确定之后才能进行核销！");
                     return 0;
                  }

                  var3 = this.getMasterModel().getItemValue(var2, "total");
                  var5 = this.getMasterModel().getItemValue(var2, "premoney");
                  String var6 = this.getMasterModel().getItemValue(var2, "recexpmoney");
                  if (DecimalHelper.toDec(var3).compareTo(DecimalHelper.toDec(DecimalHelper.add(var5, var6, 2))) <= 0) {
                     this.errorMessage("错误", "预收款已经核销完，你不能再次核销！");
                     return 0;
                  }
               } else {
                  var3 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
                  if (!"2".equals(var3)) {
                     this.errorMessage("错误", "收欠款,当前总单必须是临时状态才能自动生成!");
                     return 0;
                  }

                  if (var4 == null || var4.equals("")) {
                     this.errorMessage("错误", "请选择客户之后再由结算单生成");
                     return 0;
                  }
               }

               if ((var3 = this.getMasterModel().getItemValue(var2, "rectypeid")) != null && !var3.equals("")) {
                  var3 = this.getMasterModel().getItemValue(var2, "agentid");
                  var5 = this.getMasterModel().getItemValue(var2, "presalerid");
                  "".equals(var5);
                  if (var3.equals("") || var3 == null) {
                     var3 = "-1";
                  }

                  DBTableModel var10 = null;
                  var3 = "select sum(nvl(total_line, 0) - nvl(totalrecmoney, 0)) money  from bms_sa_settle_dtlqry_v where abs(nvl(totalrecmoney,0)) < abs(nvl(total_line,0))  and entryid = " + this.getEntryid() + " and nvl(invalidflag, 0) = 0 and usestatus = 1  and customid = " + var4 + " and nvl(agentid,-1)=" + var3 + " ";
                  if ((var4 = this.getMasterModel().getItemValue(var2, "presalerid")) != null && var4.length() > 0) {
                     var3 = var3 + " and salerid = " + var4;
                  }

                  RemotesqlHelper var9 = new RemotesqlHelper();

                  try {
                     var10 = var9.doSelect(var3, 0, 1);
                  } catch (Exception var7) {
                     var7.printStackTrace();
                  }

                  if (var10 != null) {
                     if ((var3 = var10.getItemValue(0, "money")) != null && !var3.equals("") && DecimalHelper.toDec(var3).compareTo(DecimalHelper.toDec("0")) != 0) {
                        a = this.getMasterModel().getItemValue(var2, "customname");
                        b = var3;
                        a var8;
                        (var8 = new a(this.frame, "自动生成收款单")).pack();
                        var8.setLocation((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth() - (double)var8.getWidth()) / 2.0), (int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight() - (double)var8.getHeight()) / 2.0));
                        var8.setVisible(true);
                     } else {
                        this.warnMessage("警告", "没有欠款！");
                     }
                  }
               } else {
                  this.errorMessage("错误", "请选择结算方式后再有结算单生成");
               }
            } else {
               this.errorMessage("错误", "请选择收款类别后再由结算单生成！");
            }
         }

         return 0;
      }
   }

   public void genfromsaset() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) < 0) {
         this.errorMessage("错误", "请新增总单或选择一条预收款再由结算单生成！");
      } else {
         String var2;
         if ((var2 = this.getMasterModel().getItemValue(var1, "recmethod")) != null && !var2.equals("")) {
            String var3;
            if ("1".equals(var2)) {
               var3 = this.getMasterModel().getItemValue(var1, "usestatus");
               if (!"1".equals(var3)) {
                  this.errorMessage("错误", "预收款必须确定之后才能进行核销！");
                  return;
               }

               var3 = this.getMasterModel().getItemValue(var1, "total");
               String var4 = this.getMasterModel().getItemValue(var1, "premoney");
               String var5 = this.getMasterModel().getItemValue(var1, "recexpmoney");
               if (DecimalHelper.toDec(var3).compareTo(DecimalHelper.toDec(DecimalHelper.add(var4, var5, 2))) <= 0) {
                  this.errorMessage("错误", "预收款已经核销完，你不能再次核销！");
                  return;
               }
            } else if (this.getMasterModel().getdbStatus(var1) == 1) {
               if ((var3 = this.getMasterModel().getItemValue(var1, "customid")) == null || var3.equals("")) {
                  this.errorMessage("错误", "请选择客户之后再由结算单生成");
                  return;
               }
            } else {
               var3 = this.getMasterModel().getItemValue(var1, "usestatus");
               if (!"2".equals(var3)) {
                  this.errorMessage("错误", "收欠款,当前总单必须是临时状态才能由结算单生成!");
                  return;
               }
            }

            if ((var3 = this.getMasterModel().getItemValue(var1, "rectypeid")) != null && !var3.equals("")) {
               var3 = this.getApvalue("勾兑模式");
               b var6;
               if ("1".equals(var3)) {
                  var6 = this.doTickMde(var1, var2);
               } else {
                  var6 = this.doTickSte(var1, var2);
               }

               while(var6.b) {
                  if (!var6.c) {
                     var6 = this.doTickMde(var1, var2);
                  } else {
                     var6 = this.doTickSte(var1, var2);
                  }
               }

               if (var6.a != null) {
                  if (var6.c) {
                     CMdeModel var8 = ((Bms_sa_rec_tick_mde_hov)this.f).getMdemodel();
                     ((Bms_sa_rec_detail)this.getDetailModel()).gensarecdtl(var8);
                     this.getDetailModel().tableChanged();
                     this.getMasterModel().tableChanged();
                  } else {
                     CTable var7 = ((Bms_sa_set_tick_hov)this.f).getTable();
                     ((Bms_sa_rec_detail)this.getDetailModel()).gensarecdtl(var7);
                     this.getDetailModel().tableChanged();
                     this.getMasterModel().tableChanged();
                  }
               }
            } else {
               this.errorMessage("错误", "请选择结算方式后再由结算单生成");
            }
         } else {
            this.errorMessage("错误", "请选择收款类别后再由结算单生成！");
         }
      }
   }

   public void confirm() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0 && var1 != this.getMasterModel().getRowCount()) {
         if (this.getMasterModel().getdbStatus(var1) != 0) {
            this.errorMessage("错误", "当前行状态必须是保存过后的！");
         } else {
            String var2 = this.getMasterModel().getItemValue(var1, "usestatus");
            if (!"2".equals(var2)) {
               this.errorMessage("错误", "请选择一条临时的收款进行确定！");
            } else if (!this.a(this.getMasterModel().getTable().getSelectedRow())) {
               this.infoMessage("提示", "细单中有麻黄碱类药品，不允许现金结账");
            } else {
               ClientRequest var11 = new ClientRequest();
               StringCommand var3 = new StringCommand("Bms_sa_rec_mde.确定销售收款单");
               DBTableModel var4;
               (var4 = a()).appendRow();
               String var9 = this.getMasterModel().getItemValue(var1, "sarecid");
               var4.setItemValue(0, "sarecid", var9);
               DataCommand var10;
               (var10 = new DataCommand()).setDbmodel(var4);
               var11.addCommand(var3);
               var11.addCommand(var10);
               var11.addCommand(new StringCommand(this.getEntryid()));
               this.setWaitCursor();
               var9 = null;

               try {
                  ServerResponse var12 = SendHelper.sendRequest(var11);
                  this.a(var12, "确定", 2, 5, 1);
                  return;
               } catch (Exception var7) {
                  this.errorMessage("错误", "确定不成功原因:" + var7.getMessage());
                  var7.printStackTrace();
               } finally {
                  this.setDefaultCursor();
               }

            }
         }
      } else {
         this.errorMessage("错误", "请选择一条临时的收款进行确定！");
      }
   }

   public void unconfirm() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0 && var1 != this.getMasterModel().getRowCount()) {
         if (this.getMasterModel().getdbStatus(var1) != 0) {
            this.errorMessage("错误", "当前行状态必须是保存过后的！");
         } else {
            String var2 = this.getMasterModel().getItemValue(var1, "usestatus");
            if (!"1".equals(var2)) {
               this.errorMessage("错误", "请选择一条正式的收款进行回退确定！");
            } else {
               var2 = this.getMasterModel().getItemValue(var1, "sarecid");
               String var3 = "select 1 from bms_sa_rec_dtl   where  correctflag in (1,2,3) and sarecid = " + var2;
               RemotesqlHelper var4 = new RemotesqlHelper();
               DBTableModel var5 = null;

               try {
                  if ((var5 = var4.doSelect(var3, 0, 1)) != null && var5.getRowCount() > 0) {
                     this.errorMessage("错误", "此单据已经进行收款冲调，所以不能回退确定！");
                     return;
                  }
               } catch (Exception var9) {
                  var9.printStackTrace();
                  return;
               }

               var3 = this.getMasterModel().getItemValue(var1, "recmethod");
               String var12 = this.getMasterModel().getItemValue(var1, "total_lines");
               if ("1".equals(var3)) {
                  if (var12 == null || "".equals(var12)) {
                     var12 = "0";
                  }

                  if (DecimalHelper.toDec(var12).compareTo(DecimalHelper.toDec("0")) > 0) {
                     this.errorMessage("错误", "预收核销的收款单不能回退确定！");
                     return;
                  }
               } else {
                  for(var1 = 0; var1 < this.getDetailModel().getRowCount(); ++var1) {
                  }
               }

               if (!"1".equals(var3) && !"3".equals(var3)) {
                  this.errorMessage("错误", "不能选择现收类别的收款单进行回退确定！");
               } else {
                  ClientRequest var14 = new ClientRequest();
                  StringCommand var16 = new StringCommand("Bms_sa_rec_mde.回退确定销售收款单");
                  DBTableModel var17;
                  (var17 = a()).appendRow();
                  var17.setItemValue(0, "sarecid", var2);
                  DataCommand var13;
                  (var13 = new DataCommand()).setDbmodel(var17);
                  var14.addCommand(var16);
                  var14.addCommand(var13);
                  var14.addCommand(new StringCommand(this.getEntryid()));
                  this.setWaitCursor();
                  var2 = null;

                  try {
                     ServerResponse var15 = SendHelper.sendRequest(var14);
                     this.a(var15, "回退确定", 2, 5, 1);
                     return;
                  } catch (Exception var10) {
                     this.errorMessage("错误", "回退确定不成功原因:" + var10.getMessage());
                     var10.printStackTrace();
                  } finally {
                     this.setDefaultCursor();
                  }

               }
            }
         }
      } else {
         this.errorMessage("错误", "请选择一条临时的收款进行回退确定！");
      }
   }

   public void prerecinvalid() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0 && var1 != this.getMasterModel().getDBtableModel().getRowCount()) {
         for(int var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.errorMessage("错误", "没有保存不能作废,请先保存!");
               return;
            }
         }

         String var13 = this.getMasterModel().getItemValue(var1, "usestatus");
         if ("0".equals(var13)) {
            this.errorMessage("错误", "请选择正式的预收款进行作废！");
         } else {
            var13 = this.getMasterModel().getItemValue(var1, "recmethod");
            String var3;
            if ((var3 = this.getMasterModel().getItemValue(var1, "total_lines")) == null || "".equals(var3)) {
               var3 = "0";
            }

            if ("1".equals(var13) && DecimalHelper.toDec(var3).compareTo(DecimalHelper.toDec("0")) <= 0) {
               String var11 = this.getMasterModel().getItemValue(var1, "sarecid");
               var13 = "select 1 from bms_sa_rec_dtl   where  correctflag in (1,2,3) and sarecid = " + var11;
               RemotesqlHelper var15 = new RemotesqlHelper();
               DBTableModel var4 = null;

               try {
                  if ((var4 = var15.doSelect(var13, 0, 1)) != null && var4.getRowCount() > 0) {
                     this.errorMessage("错误", "此单据已经进行收款冲调，所以不能作废！");
                     return;
                  }
               } catch (Exception var10) {
                  var10.printStackTrace();
                  return;
               }

               Vector var14 = new Vector();
               DBColumnDisplayInfo var17 = new DBColumnDisplayInfo("sarecid", "number");
               var14.add(var17);
               var17 = new DBColumnDisplayInfo("message", "varchar");
               var14.add(var17);
               var17 = new DBColumnDisplayInfo("usestatus", "number");
               var14.add(var17);
               var17 = new DBColumnDisplayInfo("total", "number");
               var14.add(var17);
               var17 = new DBColumnDisplayInfo("premoney", "number");
               var14.add(var17);
               var17 = new DBColumnDisplayInfo("oldprerecid", "number");
               var14.add(var17);
               DBTableModel var16;
               (var16 = new DBTableModel(var14)).appendRow();
               var16.setItemValue(0, "sarecid", var11);
               ClientRequest var12 = new ClientRequest();
               StringCommand var20 = new StringCommand("Bms_sa_rec_mde.作废预收款");
               DataCommand var18;
               (var18 = new DataCommand()).setDbmodel(var16);
               var12.addCommand(var20);
               var12.addCommand(var18);
               var13 = null;
               this.setWaitCursor();

               try {
                  ServerResponse var19 = SendHelper.sendRequest(var12);
                  this.a(var19, "预收款作废", 2, 5, 0);
                  return;
               } catch (Exception var8) {
                  var8.printStackTrace();
                  this.errorMessage("错误", "作废不成功,原因:" + var8.getMessage());
               } finally {
                  this.setDefaultCursor();
               }

            } else {
               this.errorMessage("错误", "请选择未核销的预收款进行作废！");
            }
         }
      }
   }

   public void invalid() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0 && var1 != this.getMasterModel().getDBtableModel().getRowCount()) {
         for(int var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.errorMessage("错误", "没有保存不能作废,请先保存!");
               return;
            }
         }

         if (this.getDetailModel().getRow() < 0) {
            this.errorMessage("错误", "请选择要作废的细单!");
         } else if (this.getDetailModel().getRow() == this.getDetailModel().getDBtableModel().getRowCount()) {
            this.errorMessage("错误", "请选择要作废的细单!");
         } else {
            String var15 = this.getMasterModel().getItemValue(var1, "usestatus");
            if ("0".equals(var15)) {
               this.errorMessage("错误", "请选择正常的收款细单进行作废！");
            } else if (!"1".equals(var15)) {
               this.errorMessage("错误", "只有正式状态下的总单才能作废！");
            } else {
               var15 = this.getMasterModel().getItemValue(var1, "recmethod");
               if (!"1".equals(var15) && !"3".equals(var15)) {
                  this.errorMessage("错误", "不能选择现收类别的细单进行作废！");
               } else {
                  int[] var16;
                  int var3 = (var16 = this.getDetailModel().getTable().getSelectedRows()).length;
                  if (this.getDetailModel().getTable().getSelectedRow() == this.getDetailModel().getTable().getRowCount() - 1) {
                     this.errorMessage("错误", "选中行错误,请重新选择!");
                  } else {
                     if (var16[var16.length - 1] == this.getDetailModel().getRowCount()) {
                        --var3;
                     }

                     String var14 = this.getMasterModel().getItemValue(var1, "sarecid");
                     String var4 = "select 1 from bms_sa_rec_dtl   where  correctflag in (1,2,3) and sarecid = " + var14;
                     RemotesqlHelper var5 = new RemotesqlHelper();
                     DBTableModel var6 = null;

                     try {
                        if ((var6 = var5.doSelect(var4, 0, 1)) != null && var6.getRowCount() > 0) {
                           this.errorMessage("错误", "此单据已经进行收款冲调，所以不能回退确定！");
                           return;
                        }
                     } catch (Exception var13) {
                        var13.printStackTrace();
                        return;
                     }

                     Vector var17 = new Vector();
                     DBColumnDisplayInfo var19 = new DBColumnDisplayInfo("sarecdtlid", "number");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("message", "varchar");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("sarecid", "number");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("usestatus", "number");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("invalidflag", "number");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("invalidmanid", "number");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("invalidmanname", "varchar");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("invalidtime", "date");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("dtl_lines", "number");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("total", "number");
                     var17.add(var19);
                     var19 = new DBColumnDisplayInfo("premoney", "number");
                     var17.add(var19);
                     DBTableModel var18 = new DBTableModel(var17);

                     for(int var25 = 0; var25 < var3; ++var25) {
                        String var20 = this.getDetailModel().getItemValue(var16[var25], "invalidflag");
                        if (!"1".equals(var20)) {
                           if (this.getDetailModel().getdbStatus(var16[var25]) != 0) {
                              this.errorMessage("错误", "第" + (var16[var25] + 1) + "行细单没有保存不能作废,请先保存!");
                              return;
                           }

                           String var7 = this.getDetailModel().getItemValue(var16[var25], "sarecdtlid");
                           int var21 = var18.getRowCount();
                           var18.appendRow();
                           var18.setItemValue(var21, "sarecdtlid", var7);
                           var18.setItemValue(var21, "sarecid", var14);
                        }
                     }

                     if (var18.getRowCount() > 0) {
                        ClientRequest var26 = new ClientRequest();
                        StringCommand var22 = new StringCommand("Bms_sa_rec_mde.作废销售收款单");
                        DataCommand var23;
                        (var23 = new DataCommand()).setDbmodel(var18);
                        var26.addCommand(var22);
                        var26.addCommand(var23);
                        var26.addCommand(new StringCommand(this.getEntryid()));
                        var6 = null;
                        this.setWaitCursor();

                        try {
                           ServerResponse var24 = SendHelper.sendRequest(var26);
                           this.a(var24, "作废");
                           return;
                        } catch (Exception var11) {
                           var11.printStackTrace();
                           this.errorMessage("错误", "作废不成功,原因:" + var11.getMessage());
                        } finally {
                           this.setDefaultCursor();
                        }

                     }
                  }
               }
            }
         }
      }
   }

   private static DBTableModel a() {
      Vector var0 = new Vector();
      DBColumnDisplayInfo var1 = new DBColumnDisplayInfo("sarecid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("message", "varchar");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("usestatus", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmmanid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmmanname", "varchar");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmdate", "date");
      var0.add(var1);
      return new DBTableModel(var0);
   }

   private void a(ServerResponse var1, String var2, int var3, int var4, int var5) {
      String var6;
      if (!(var6 = var1.getCommand()).startsWith("+OK")) {
         this.errorMessage("错误", var6);
      } else {
         DBTableModel var14 = this.getMasterModel().getDBtableModel();
         String var7 = "sarecid";
         if (var5 == 0) {
            var14 = this.getDetailModel().getDBtableModel();
            var7 = "sarecdtlid";
         }

         DBTableModel var13 = ((DataCommand)var1.commandAt(1)).getDbmodel();

         for(int var8 = 0; var8 < var13.getRowCount(); ++var8) {
            String var9 = var13.getItemValue(var8, var7);
            String var10 = var13.getItemValue(var8, "message");

            for(int var11 = 0; var11 < var14.getRowCount(); ++var11) {
               if (var14.getItemValue(var11, var7).equals(var9)) {
                  if (!var10.startsWith("+OK")) {
                     var14.getRecordThunk(var11).setSaveresult(1, var10);
                     break;
                  }

                  for(int var15 = var3; var15 <= var4; ++var15) {
                     var10 = var13.getColumnDBName(var15);
                     var14.setItemValue(var11, var10, var13.getItemValue(var8, var10));
                  }

                  var14.setdbStatus(var11, 0);
                  var14.getRecordThunk(var11).setSaveresult(0, var2 + "成功");
                  break;
               }
            }
         }

         if (var5 == 1) {
            this.getMasterModel().tableChanged();
         } else if (var5 == 0) {
            this.getDetailModel().tableChanged();
         }

         this.getMasterModel().tableChanged();
      }
   }

   private void a(ServerResponse var1, String var2) {
      String var3;
      if (!(var3 = var1.getCommand()).startsWith("+OK")) {
         this.errorMessage("错误", var3);
      } else {
         this.a(var1, var2, 4, 7, 0);
         DBTableModel var7;
         int var8 = (var7 = ((DataCommand)var1.commandAt(1)).getDbmodel()).getRowCount() - 1;
         var3 = var7.getItemValue(var8, "sarecid");
         DBTableModel var4 = this.getMasterModel().getDBtableModel();

         for(int var5 = 0; var5 < var4.getRowCount(); ++var5) {
            if (var4.getItemValue(var5, "sarecid").equals(var3)) {
               var4.setItemValue(var5, "usestatus", var7.getItemValue(var8, "usestatus"));
               var4.setItemValue(var5, "dtl_lines", var7.getItemValue(var8, "dtl_lines"));
               var4.setItemValue(var5, "total", var7.getItemValue(var8, "total"));
               var4.setItemValue(var5, "premoney", var7.getItemValue(var8, "premoney"));
               var4.setdbStatus(var5, 0);
               this.getMasterModel().tableChanged();
               return;
            }
         }

      }
   }

   public void createbmsrec() {
      String var1;
      boolean var2 = a(var1 = c.getText());
      int var3 = this.getMasterModel().getRow();
      DBTableModel var4 = null;
      String var5 = this.getMasterModel().getItemValue(var3, "customid");
      String var6;
      if ((var6 = this.getMasterModel().getItemValue(var3, "agentid")).equals("") || var6 == null) {
         var6 = "-1";
      }

      String var7 = this.getMasterModel().getItemValue(var3, "recmethod");
      String var8 = "select *  from bms_sa_settle_dtlqry_v where abs(nvl(totalrecmoney,0)) < abs(nvl(total_line,0))  and nvl(invalidflag, 0) = 0 and usestatus = 1  and entryid = " + this.getEntryid() + " and customid = " + var5 + " and nvl(agentid,-1)=" + var6 + " and total_line <= 0 ";
      if ("1".equals(var7)) {
         String var9 = this.getMasterModel().getItemValue(var3, "presalerid");
         var8 = var8 + " and salerid = " + var9;
      }

      var8 = var8 + "  order by confirmdate ";
      RemotesqlHelper var18 = new RemotesqlHelper();

      try {
         var4 = var18.doSelect(var8, 0, 1000);
      } catch (Exception var15) {
         var15.printStackTrace();
      }

      var8 = "select *  from bms_sa_settle_dtlqry_v where abs(nvl(totalrecmoney,0)) < abs(nvl(total_line,0))  and nvl(invalidflag, 0) = 0 and usestatus = 1  and entryid = " + this.getEntryid() + " and customid = " + var5 + " and nvl(agentid,-1)=" + var6 + " and total_line > 0  ";
      String var10;
      if ("1".equals(var7)) {
         var10 = this.getMasterModel().getItemValue(var3, "presalerid");
         var8 = var8 + " and  salerid = " + var10;
      }

      var8 = var8 + " order by confirmdate ";
      var18 = new RemotesqlHelper();
      var10 = null;

      try {
         DBTableModel var20 = var18.doSelect(var8, 0, 1000);
         if (var2) {
            var4.appendDbmodel(var20);
         } else {
            var20.appendDbmodel(var4);
            var4 = var20;
         }
      } catch (Exception var14) {
         var14.printStackTrace();
      }

      if (var4 != null && var4.getRowCount() > 0) {
         DBTableModel var16 = this.getDetailModel().getDBtableModel();
         var7 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "recmethod");
         Userruninfo var17 = ClientUserManager.getCurrentUser();
         boolean var21 = DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec("0")) > 0;
         if (!var2) {
            var21 = DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec("0")) < 0;
         }

         for(int var19 = 0; var19 < var4.getRowCount() && var21; ++var19) {
            var8 = var4.getItemValue(var19, "total_line");
            var10 = var4.getItemValue(var19, "totalrecmoney");
            var8 = DecimalHelper.sub(var8, var10, 2);
            boolean var22 = DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec(var8)) <= 0;
            if (!var2) {
               var22 = DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec(var8)) >= 0;
            }

            String var11 = "0";
            String var12 = var4.getItemValue(var19, "unitprice");
            if (var22) {
               var10 = var1;
               var1 = DecimalHelper.sub(var1, var1, 2);
               if (var12 != null && !var12.equals("")) {
                  var11 = DecimalHelper.divide(var10, var4.getItemValue(var19, "unitprice"), 6);
               }
            } else {
               var10 = var8;
               var1 = DecimalHelper.sub(var1, var8, 2);
               var11 = var4.getItemValue(var19, "goodsqty");
            }

            int var13 = var16.getRowCount();
            var16.appendRow();
            var16.setItemValue(var13, "goodsid", var4.getItemValue(var19, "goodsid"));
            var16.setItemValue(var13, "opcode", var4.getItemValue(var19, "opcode"));
            var16.setItemValue(var13, "goodsno", var4.getItemValue(var19, "goodsno"));
            var16.setItemValue(var13, "goodsname", var4.getItemValue(var19, "goodsname"));
            var16.setItemValue(var13, "currencyname", var4.getItemValue(var19, "currencyname"));
            var16.setItemValue(var13, "goodstype", var4.getItemValue(var19, "goodstype"));
            var16.setItemValue(var13, "goodsunit", var4.getItemValue(var19, "goodsunit"));
            var16.setItemValue(var13, "prodarea", var4.getItemValue(var19, "prodarea"));
            var16.setItemValue(var13, "factoryname", var4.getItemValue(var19, "factoryname"));
            var16.setItemValue(var13, "factoryid", var4.getItemValue(var19, "factoryid"));
            var16.setItemValue(var13, "goodsqty", var11);
            var16.setItemValue(var13, "unitprice", var12);
            var16.setItemValue(var13, "total_line", var10);
            var16.setItemValue(var13, "sasettledtlid", var4.getItemValue(var19, "sasettledtlid"));
            var16.setItemValue(var13, "invalidflag", "0");
            var16.setItemValue(var13, "salerid", var4.getItemValue(var19, "salerid"));
            var16.setItemValue(var13, "salername", var4.getItemValue(var19, "salername"));
            var16.setItemValue(var13, "salesdeptid", var4.getItemValue(var19, "salesdeptid"));
            var16.setItemValue(var13, "salesdeptname", var4.getItemValue(var19, "salesdeptname"));
            var16.setItemValue(var13, "recsalerid", var17.getUserid());
            var16.setItemValue(var13, "recsalername", var17.getUsername());
            var16.setItemValue(var13, "recsalesdeptid", var17.getDeptid());
            var16.setItemValue(var13, "recsalesdeptname", var17.getDeptname());
            if ("1".equals(var7)) {
               var16.setItemValue(var13, "cdate", NpbusiDBHelper.getSysdate());
               if ((var8 = this.getMasterModel().getItemValue(var3, "exchange")) == null || var8.equals("")) {
                  var8 = "1";
               }

               var16.setItemValue(var13, "exchange", var8);
            }

            var21 = DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec("0")) > 0;
            if (!var2) {
               var21 = DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec("0")) < 0;
            }

            var16.setItemValue(var13, "settype", var4.getItemValue(var19, "settype"));
            ((Bms_sa_rec_detail)this.getDetailModel()).on_itemvaluechange(var13, "total_line", var4.getItemValue(var19, "thistickmoney"));
         }

         this.getDetailModel().tableChanged();
         if ("1".equals(var7)) {
            var10 = DecimalHelper.add(NpbusiDBHelper.getPreRecmoney(this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "sarecid")), var16.sum("total_line").toString(), 2);
            ((Bms_sa_rec_master)this.getMasterModel()).setItemValue(this.getMasterModel().getRow(), "premoney", var10);
            ((Bms_sa_rec_master)this.getMasterModel()).on_itemvaluechange(this.getMasterModel().getRow(), "premoney", var10);
         } else {
            ((Bms_sa_rec_master)this.getMasterModel()).on_itemvaluechange(this.getMasterModel().getRow(), "premoney", var16.sum("total_line").toString());
         }

         this.getMasterModel().tableChanged(this.getMasterModel().getRow());
         this.getMasterModel().tableChanged();
      }
   }

   private static boolean a(String var0) {
      boolean var1 = true;
      if (DecimalHelper.toDec(var0).compareTo(DecimalHelper.toDec("0")) < 0) {
         var1 = false;
      }

      return var1;
   }

   protected b doTickSte(int var1, String var2) {
      this.f = new Bms_sa_set_tick_hov();
      Bms_sa_set_tick_hov var3;
      (var3 = (Bms_sa_set_tick_hov)this.f).setFmid(this.getMasterModel().getItemValue(var1, "fmid"));
      var3.setExchange(this.getMasterModel().getItemValue(var1, "exchange"));
      String var4 = this.getMasterModel().getItemValue(var1, "entryid");
      String var5 = this.getMasterModel().getItemValue(var1, "customid");
      var3.setCustomid(var5);
      String var6;
      if ((var6 = this.getMasterModel().getItemValue(var1, "agentid")).equals("") || var6 == null) {
         var6 = "-1";
      }

      var4 = " customid = " + var5 + " and entryid = " + var4 + " and nvl(agentid,-1)=" + var6;
      var5 = this.getMasterModel().getItemValue(var1, "total");
      var6 = this.getMasterModel().getItemValue(var1, "premoney");
      if ("1".equals(var2)) {
         var3.thisrecmoney.setEditable(false);
         var2 = this.getMasterModel().getItemValue(var1, "recexpmoney");
         var3.thisrecmoney.setText(DecimalHelper.sub(DecimalHelper.sub(var5, var6, 2), var2, 2));
      } else {
         var3.thisrecmoney.setEditable(true);
      }

      if ((var2 = this.getMasterModel().getItemValue(var1, "presalerid")) != null && var2.length() > 0) {
         var4 = var4 + " and salerid = " + var2;
      }

      DBTableModel var7 = this.f.showDialog(this.frame, "选择销售结算单", "customid", "%", var4);
      b var8;
      (var8 = new b(this)).a = var7;
      var8.b = var3.isext;
      return var8;
   }

   protected b doTickMde(int var1, String var2) {
      this.f = new Bms_sa_rec_tick_mde_hov();
      Bms_sa_rec_tick_mde_hov var3;
      (var3 = (Bms_sa_rec_tick_mde_hov)this.f).setFmid(this.getMasterModel().getItemValue(var1, "fmid"));
      var3.setExchange(this.getMasterModel().getItemValue(var1, "exchange"));
      String var4 = this.getMasterModel().getItemValue(var1, "entryid");
      String var5 = this.getMasterModel().getItemValue(var1, "customid");
      var3.setCustomid(var5);
      String var6;
      if ((var6 = this.getMasterModel().getItemValue(var1, "agentid")).equals("") || var6 == null) {
         var6 = "-1";
      }

      var4 = " customid = " + var5 + " and entryid = " + var4 + " and nvl(agentid,-1)=" + var6;
      var5 = this.getMasterModel().getItemValue(var1, "total");
      var6 = this.getMasterModel().getItemValue(var1, "premoney");
      if ("1".equals(var2)) {
         var3.thisrecmoney.setEditable(false);
         var2 = this.getMasterModel().getItemValue(var1, "recexpmoney");
         var3.thisrecmoney.setText(DecimalHelper.sub(DecimalHelper.sub(var5, var6, 2), var2, 2));
         var2 = this.getMasterModel().getItemValue(var1, "presalerid");
         var5 = " salerid = " + var2;
         var3.setDetailOtherWhere(var5);
      } else {
         var3.thisrecmoney.setEditable(true);
      }

      if ((var2 = this.mastermodel.getItemValue(var1, "presalerid")) != null && var2.length() > 0) {
         var3.setDetailOtherWhere("salerid=" + var2);
      }

      var3.setOtherwheres(var4);
      DBTableModel var7 = this.f.showDialog(this.frame, "选择销售结算单");
      b var8;
      (var8 = new b(this)).a = var7;
      var8.b = var3.isext;
      var8.c = true;
      return var8;
   }

   private boolean a(int var1) {
      DBTableModel var2;
      int var3 = (var2 = this.getDetaildbmodel(var1)).getRowCount();
      boolean var4 = false;

      for(int var5 = 0; var5 < var3; ++var5) {
         if ("1".equals(var2.getItemValue(var5, "ephedrine"))) {
            var4 = true;
            break;
         }
      }

      if (var4) {
         String var10 = this.getMasterModel().getItemValue(var1, "rectypeid");
         String var7 = "select settletype from pub_settletype_sa_v where settletypeid = " + var10;
         RemotesqlHelper var8 = new RemotesqlHelper();
         DBTableModel var9 = null;

         try {
            var9 = var8.doSelect(var7, 0, 1);
         } catch (Exception var6) {
            this.infoMessage("错误", "药品中含有麻黄碱类药品，无法检索支付类型");
            var6.printStackTrace();
         }

         if (var9 == null || var9.getRowCount() <= 0) {
            return false;
         }

         var7 = var9.getItemValue(0, "settletype");
         if ("现金".equals(var7)) {
            return false;
         }
      }

      return true;
   }

   // $FF: synthetic method
   static boolean a(Bms_sa_rec_mde var0, String var1) {
      return a(var1);
   }

   // $FF: synthetic method
   static int a(Bms_sa_rec_mde var0, String var1, String var2) {
      int var5 = 1;
      boolean var3 = a(var1);
      boolean var4 = a(var2);
      if (var3 && var4) {
         var5 = DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec(var2));
      } else if (!var3 && !var4) {
         var5 = -DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec(var2));
      } else if (!a(var1) && DecimalHelper.toDec(var2).compareTo(DecimalHelper.toDec("0")) == 0) {
         var5 = 1;
      } else if (!a(var2) && DecimalHelper.toDec(var1).compareTo(DecimalHelper.toDec("0")) == 0) {
         var5 = -1;
      }

      return var5;
   }

   class a extends CDialog {
      private static final long serialVersionUID = 4650007368359708573L;

      a(Frame var2, String var3) {
         super(var2, var3);
         this.setModal(true);
         Container var6;
         (var6 = this.getContentPane()).setPreferredSize(new Dimension(500, 120));
         var6.setLayout(new BorderLayout());
         JPanel var7 = new JPanel();
         JLabel var4 = new JLabel("客户为：" + Bms_sa_rec_mde.a + "的客户的所有欠款金额为：" + Bms_sa_rec_mde.b + " 元!");
         var7.add(var4);
         var6.add(var7, "North");
         var7 = new JPanel();
         var4 = new JLabel("本次收款金额:");
         var7.add(var4);
         (Bms_sa_rec_mde.c = new CNumberTextField(2)).setPreferredSize(new Dimension(100, 27));
         var7.add(Bms_sa_rec_mde.c);
         var7.add(new JLabel("元"));
         var6.add(var7, "Center");
         var7 = new JPanel();
         JButton var8;
         (var8 = new JButton("确定")).setActionCommand("ok");
         var8.addActionListener(new a(this));
         var8.setFocusable(false);
         JButton var5;
         (var5 = new JButton("取消")).setActionCommand("cancel");
         var5.addActionListener(new a(this));
         var5.setFocusable(false);
         var7.add(var8);
         var7.add(var5);
         var6.add(var7, "South");
      }

      class a implements ActionListener {
         private a a;

         public a(a var2) {
            this.a = var2;
         }

         public final void actionPerformed(ActionEvent var1) {
            if (var1.getActionCommand().equals("ok")) {
               String var2 = Bms_sa_rec_mde.c.getText();
               if (Bms_sa_rec_mde.a((Bms_sa_rec_mde)Bms_sa_rec_mde.this, Bms_sa_rec_mde.b) && !Bms_sa_rec_mde.a((Bms_sa_rec_mde)Bms_sa_rec_mde.this, var2)) {
                  a.this.errorMessage("错误", "此处不能退款，请点击'由结算单生成'按钮进行退款！");
               } else if (!Bms_sa_rec_mde.a((Bms_sa_rec_mde)Bms_sa_rec_mde.this, Bms_sa_rec_mde.b) && Bms_sa_rec_mde.a((Bms_sa_rec_mde)Bms_sa_rec_mde.this, var2)) {
                  a.this.errorMessage("错误", "此处不能收款，请点击'由结算单生成'按钮进行收款！");
               } else if (Bms_sa_rec_mde.a(Bms_sa_rec_mde.this, var2, Bms_sa_rec_mde.b) > 0) {
                  JOptionPane.showMessageDialog(this.a, "收款金额大于欠款金额！");
               } else {
                  this.a.setVisible(false);
                  Bms_sa_rec_mde.this.createbmsrec();
               }
            } else if (var1.getActionCommand().equals("cancel")) {
               this.a.setVisible(false);
               Bms_sa_rec_mde.c.setText("");
            }
         }
      }
   }

   class b {
      DBTableModel a;
      boolean b = false;
      boolean c = false;

      b(Bms_sa_rec_mde var1) {
      }
   }
}
